import bpy
#by Expert Multimedia
#Works Cited: http://wiki.blender.org/index.php/Dev:2.5/Py/Scripts/Cookbook/Code_snippets/Interface
#
#    Menu in tools region
#
       
        
class OffsetOneOriginOperator(bpy.types.Panel):
    """ This operator moves the origin down one.
    """
 #       the multiline string above is used for the tooltip and API docs.
    #bl_idname = "wm.offsetOneorigin"
    bl_label = "Offset One"
    bl_space_type = "VIEW_3D"
    bl_region_type = "TOOLS"
    #bl_space_type = "PROPERTIES"
    #bl_region_type = "WINDOW"
    #bl_context = "object"
 
    def draw(self, context):
        #self.layout.operator("hello.hello", text='Bonjour').country = "France"
        #self.layout.operator("wm.offsetoneorigin", text='OffsetZ').value = -1.0
        self.layout.operator("wm.offsetoneorigin")
    
    def execute(self, context):
        
        ### OPTIONS ###
        sBaseName="Cube"
        xChange=0.0
        yChange=0.0
        zChange=-1.0
        bRoundRot=True
        bRoundLoc=True
        ### END OPTIONS ###
        
        iDone=0
        bpy.ops.object.mode_set(mode='OBJECT')
        #objNow.update()
        objPrev=None
        
        #sNow = str(iNow)
        #while len(sNow)<3:
        #    sNow='0'+sNow
        #sNow='.'+sNow
        #if iNow==0:
        #    sNow=""
        # store the location of current 3d cursor
        #sNameNow=sBaseName+sNow
        #objNow=None


        #vecCursorOld=scene.cursor_location
        #bpy.context.scene.objects.active=bpy.data.objects[sNameNow]
        #for object in bpy.data.objects:
        #    object.select = False
            #object.update()
        objNow=bpy.context.scene.objects.active
        #objNow=bpy.data.objects[sNameNow]
        #objNow.update()
        #objNow.select=True
        #objNow.update()
        #if objNow!=objPrev:
        if bRoundLoc:
            objNow.location.x=round(objNow.location.x)
            objNow.location.y=round(objNow.location.y)
            objNow.location.z=round(objNow.location.z)
            #objNow.update()
        if bRoundRot:
            objNow.rotation_euler.x=round(objNow.rotation_euler.x)
            objNow.rotation_euler.y=round(objNow.rotation_euler.y)
            objNow.rotation_euler.z=round(objNow.rotation_euler.z)
            #objNow.update()
        # give 3dcursor new coordinates
        scene.cursor_location.x=objNow.location.x+xChange
        #objNow.update()
        scene.cursor_location.y=objNow.location.y+yChange
        #objNow.update()
        scene.cursor_location.z=objNow.location.z+zChange
        #objNow.update()
        
        # set the origin on the current object to the 3dcursor location:
        bpy.ops.object.origin_set(type='ORIGIN_CURSOR')
        #objNow.update()
        #else:
        #    print("FAILED (%s is still selected).",objNow.name)
        #    #scene.cursor_location = vecCursorOld
        #    iDone=iDone+1
        #    objPrev=objNow
        #    print("%s done",objNow.name)
                
        self.report({'INFO'}, str(iDone)+" seemed to work...")
        return {'FINISHED'}
        
    def invoke(self, context, event):
        self.x = event.mouse_x
        self.y = event.mouse_y
        return self.execute(context)
    
#class ExpertMultimediaPanel(bpy.types.Panel):
#    bl_label = "Expert Multimedia"
#    bl_space_type = "VIEW_3D"
#    bl_region_type = "TOOL_PROPS"
 
#    def draw(self, context):
#        self.layout.operator("wm.offsetOneorigin")
        
        
#
#	Registration
#   Not really necessary to register the class, because this happens
#   automatically when the module is registered. OTOH, it does not hurt either.
bpy.utils.register_class(OffsetOneOriginOperator)
bpy.utils.register_module(__name__)
 
# Automatically do something at startup:
#bpy.ops.wm.offsetOneorigin('INVOKE_DEFAULT')
 
# Another test call, this time call execute() directly with pre-defined settings.
#bpy.ops.wm.mouse_position('EXEC_DEFAULT', x=20, y=66)

    
        
